/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of ScoreBoard.xs. Do not edit this file, edit ScoreBoard.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "ScoreBoard.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

# undef HAVE_ATOMICS

# ifdef __GNUC__
#   define GCC_V (10000*__GNUC__ + 100*__GNUC_MINOR__ + __GNUC_PATCHLEVEL__)

#   if GCC_V >= 30000
#     define expect(expr,value) __builtin_expect ((expr),(value))
#     define INLINE static inline
#   endif

#   if GCC_V >= 40102
#     pragma message "GCC Version >= 40102: using atomic builtins"
#     define HAVE_ATOMICS 1
#     define atomic_add(ptr, v) __sync_add_and_fetch((ptr), (v))
#     define atomic_sub(ptr, v) __sync_sub_and_fetch((ptr), (v))
#   endif
# endif

# include "config.h"

# ifndef expect
#   define expect(expr,value) (expr)
# endif

# ifndef INLINE
#   define INLINE static
# endif

# ifndef atomic_add
#   define atomic_add(ptr, v) (*(ptr)+=(v))
# endif

# ifndef atomic_sub
#   define atomic_sub(ptr, v) (*(ptr)-=(v))
# endif

# ifndef HAVE_ATOMICS
#   define HAVE_ATOMICS 0
# endif

#define expect_false(expr) expect ((expr) != 0, 0)
#define expect_true(expr)  expect ((expr) != 0, 1)

typedef volatile IV vIV;
typedef volatile UV vUV;

struct hdr {
  union {
    vUV iv;
    char *c;
  } magic;
  vUV how_many;
  vUV slotsize;
  vUV extra;
};

INLINE vIV* get_slot( SV *sb, UV slot, UV *slotsize ) {
  if( expect_true((sb && SvROK(sb))) ) {
    struct hdr *hdr=(struct hdr *)SvPV_nolen(SvRV(sb));
    vIV *data=(vIV*)(sizeof(*hdr)+(char*)hdr);
    if( expect_true(slot<hdr->how_many) ) {
      if( expect_true(slotsize) ) *slotsize=hdr->slotsize;
      return &data[slot*hdr->slotsize];
    } else {
      croak("slot number out of range");
    }
  } else {
    croak("invalid scoreboard parameter");
  }
}

INLINE IV sum( SV *sb, UV idx ) {
  if( expect_true((sb && SvROK(sb))) ) {
    struct hdr *hdr=(struct hdr *)SvPV_nolen(SvRV(sb));
    vIV *data=(vIV*)(sizeof(*hdr)+(char*)hdr);
    IV res=0;
    UV i;
    if( expect_true(idx<hdr->slotsize) ) {
      for( i=0; i<hdr->how_many; i++ ) {
	res+=data[i*hdr->slotsize+idx];
      }
      return res;
    } else {
      croak("index within slot out of range");
    }
  } else {
    croak("invalid scoreboard parameter");
  }
}

INLINE vIV* get_extra( SV *sb, UV *slotsize ) {
  if( expect_true((sb && SvROK(sb))) ) {
    struct hdr *hdr=(struct hdr *)SvPV_nolen(SvRV(sb));
    vIV *data=(vIV*)(sizeof(*hdr)+(char*)hdr);
    if( expect_true(slotsize) ) *slotsize=hdr->extra;
    return &data[hdr->how_many*hdr->slotsize];
  } else {
    croak("invalid scoreboard parameter");
  }
}

#line 118 "ScoreBoard.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 262 "ScoreBoard.c"

XS_EUPXS(XS_IPC__ScoreBoard_nslots); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_nslots)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sb");
    {
	SV*	sb = ST(0)
;
	IV	RETVAL;
	dXSTARG;
#line 117 "ScoreBoard.xs"
    if( expect_true((sb && SvROK(sb))) ) {
      struct hdr *hdr=(struct hdr *)SvPV_nolen(SvRV(sb));
      RETVAL=hdr->how_many;
    } else {
      croak("invalid scoreboard parameter");
    }
#line 282 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IPC__ScoreBoard_slotsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_slotsize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sb");
    {
	SV*	sb = ST(0)
;
	IV	RETVAL;
	dXSTARG;
#line 131 "ScoreBoard.xs"
    if( expect_true((sb && SvROK(sb))) ) {
      struct hdr *hdr=(struct hdr *)SvPV_nolen(SvRV(sb));
      RETVAL=hdr->slotsize;
    } else {
      croak("invalid scoreboard parameter");
    }
#line 307 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IPC__ScoreBoard_nextra); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_nextra)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sb");
    {
	SV*	sb = ST(0)
;
	IV	RETVAL;
	dXSTARG;
#line 145 "ScoreBoard.xs"
    if( expect_true((sb && SvROK(sb))) ) {
      struct hdr *hdr=(struct hdr *)SvPV_nolen(SvRV(sb));
      RETVAL=hdr->extra;
    } else {
      croak("invalid scoreboard parameter");
    }
#line 332 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IPC__ScoreBoard_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_get)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "sb, slot, idx=0");
    {
	SV*	sb = ST(0)
;
	UV	slot = (UV)SvUV(ST(1))
;
	UV	idx;
	IV	RETVAL;
	dXSTARG;

	if (items < 3)
	    idx = 0;
	else {
	    idx = (UV)SvUV(ST(2))
;
	}
#line 161 "ScoreBoard.xs"
    UV sz;
    vIV *slotptr=get_slot(sb, slot, &sz);
#line 363 "ScoreBoard.c"
#line 164 "ScoreBoard.xs"
    if( expect_true(idx<sz) ) {
      RETVAL=slotptr[idx];
    } else {
      croak("index within slot out of range");
    }
#line 370 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IPC__ScoreBoard_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_set)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "sb, slot, idx, val");
    {
	SV*	sb = ST(0)
;
	UV	slot = (UV)SvUV(ST(1))
;
	UV	idx = (UV)SvUV(ST(2))
;
	IV	val = (IV)SvIV(ST(3))
;
	IV	RETVAL;
	dXSTARG;
#line 180 "ScoreBoard.xs"
    UV sz;
    vIV *slotptr=get_slot(sb, slot, &sz);
#line 397 "ScoreBoard.c"
#line 183 "ScoreBoard.xs"
  if( expect_true(idx<sz) ) {
      RETVAL=slotptr[idx]=val;
    } else {
      croak("index within slot out of range");
    }
#line 404 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IPC__ScoreBoard_incr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_incr)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "sb, slot, idx, amount=1");
    {
	SV*	sb = ST(0)
;
	UV	slot = (UV)SvUV(ST(1))
;
	UV	idx = (UV)SvUV(ST(2))
;
	IV	amount;
	IV	RETVAL;
	dXSTARG;

	if (items < 4)
	    amount = 1;
	else {
	    amount = (IV)SvIV(ST(3))
;
	}
#line 199 "ScoreBoard.xs"
    UV sz;
    vIV *slotptr=get_slot(sb, slot, &sz);
#line 437 "ScoreBoard.c"
#line 202 "ScoreBoard.xs"
    if( expect_true(idx<sz) ) {
      RETVAL=atomic_add(&slotptr[idx], amount);
    } else {
      croak("index within slot out of range");
    }
#line 444 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IPC__ScoreBoard_decr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_decr)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "sb, slot, idx, amount=1");
    {
	SV*	sb = ST(0)
;
	UV	slot = (UV)SvUV(ST(1))
;
	UV	idx = (UV)SvUV(ST(2))
;
	IV	amount;
	IV	RETVAL;
	dXSTARG;

	if (items < 4)
	    amount = 1;
	else {
	    amount = (IV)SvIV(ST(3))
;
	}
#line 218 "ScoreBoard.xs"
    UV sz;
    vIV *slotptr=get_slot(sb, slot, &sz);
#line 477 "ScoreBoard.c"
#line 221 "ScoreBoard.xs"
    if( expect_true(idx<sz) ) {
      RETVAL=atomic_sub(&slotptr[idx], amount);
    } else {
      croak("index within slot out of range");
    }
#line 484 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IPC__ScoreBoard_sum); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_sum)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sb, idx");
    {
	SV*	sb = ST(0)
;
	UV	idx = (UV)SvUV(ST(1))
;
	IV	RETVAL;
	dXSTARG;
#line 235 "ScoreBoard.xs"
    RETVAL=sum(sb, idx);
#line 506 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IPC__ScoreBoard_get_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_get_all)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sb, slot");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	sb = ST(0)
;
	UV	slot = (UV)SvUV(ST(1))
;
#line 245 "ScoreBoard.xs"
    UV sz, i;
    vIV *slotptr=get_slot(sb, slot, &sz);
#line 529 "ScoreBoard.c"
#line 248 "ScoreBoard.xs"
    EXTEND(SP, sz);
    for( i=0; i<sz; i++ ) {
      mPUSHi(slotptr[i]);
    }
#line 535 "ScoreBoard.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IPC__ScoreBoard_sum_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_sum_all)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	sb = ST(0)
;
#line 258 "ScoreBoard.xs"
    if( expect_true((sb && SvROK(sb))) ) {
      struct hdr *hdr=(struct hdr *)SvPV_nolen(SvRV(sb));
      vIV *data=(vIV*)(sizeof(*hdr)+(char*)hdr);
      UV i, j;
      EXTEND(SP, hdr->slotsize);
      for( j=0; j<hdr->slotsize; j++ ) {
	mPUSHi(0);
      }
      for( i=0; i<hdr->how_many; i++ ) {
	for( j=0; j<hdr->slotsize; j++ ) {
	  SvIV_set(ST(j), SvIVX(ST(j))+data[i*hdr->slotsize+j]);
	}
      }
    } else {
      croak("invalid scoreboard parameter");
    }
#line 570 "ScoreBoard.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IPC__ScoreBoard_get_extra); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_get_extra)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "sb, idx=0");
    {
	SV*	sb = ST(0)
;
	UV	idx;
	IV	RETVAL;
	dXSTARG;

	if (items < 2)
	    idx = 0;
	else {
	    idx = (UV)SvUV(ST(1))
;
	}
#line 281 "ScoreBoard.xs"
    UV sz;
    vIV *slotptr=get_extra(sb, &sz);
#line 599 "ScoreBoard.c"
#line 284 "ScoreBoard.xs"
    if( expect_true(idx<sz) ) {
      RETVAL=slotptr[idx];
    } else {
      croak("index within extra slot out of range");
    }
#line 606 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IPC__ScoreBoard_set_extra); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_set_extra)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sb, idx, val");
    {
	SV*	sb = ST(0)
;
	UV	idx = (UV)SvUV(ST(1))
;
	IV	val = (IV)SvIV(ST(2))
;
	IV	RETVAL;
	dXSTARG;
#line 299 "ScoreBoard.xs"
    UV sz;
    vIV *slotptr=get_extra(sb, &sz);
#line 631 "ScoreBoard.c"
#line 302 "ScoreBoard.xs"
  if( expect_true(idx<sz) ) {
      RETVAL=slotptr[idx]=val;
    } else {
      croak("index within extra slot out of range");
    }
#line 638 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IPC__ScoreBoard_incr_extra); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_incr_extra)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "sb, idx, amount=1");
    {
	SV*	sb = ST(0)
;
	UV	idx = (UV)SvUV(ST(1))
;
	IV	amount;
	IV	RETVAL;
	dXSTARG;

	if (items < 3)
	    amount = 1;
	else {
	    amount = (IV)SvIV(ST(2))
;
	}
#line 317 "ScoreBoard.xs"
    UV sz;
    vIV *slotptr=get_extra(sb, &sz);
#line 669 "ScoreBoard.c"
#line 320 "ScoreBoard.xs"
    if( expect_true(idx<sz) ) {
      RETVAL=atomic_add(&slotptr[idx], amount);
    } else {
      croak("index within extra slot out of range");
    }
#line 676 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IPC__ScoreBoard_decr_extra); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_decr_extra)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "sb, idx, amount=1");
    {
	SV*	sb = ST(0)
;
	UV	idx = (UV)SvUV(ST(1))
;
	IV	amount;
	IV	RETVAL;
	dXSTARG;

	if (items < 3)
	    amount = 1;
	else {
	    amount = (IV)SvIV(ST(2))
;
	}
#line 335 "ScoreBoard.xs"
    UV sz;
    vIV *slotptr=get_extra(sb, &sz);
#line 707 "ScoreBoard.c"
#line 338 "ScoreBoard.xs"
    if( expect_true(idx<sz) ) {
      RETVAL=atomic_sub(&slotptr[idx], amount);
    } else {
      croak("index within extra slot out of range");
    }
#line 714 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IPC__ScoreBoard_get_all_extra); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_get_all_extra)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	sb = ST(0)
;
#line 351 "ScoreBoard.xs"
    UV sz, i;
    vIV *slotptr=get_extra(sb, &sz);
#line 735 "ScoreBoard.c"
#line 354 "ScoreBoard.xs"
    EXTEND(SP, sz);
    for( i=0; i<sz; i++ ) {
      mPUSHi(slotptr[i]);
    }
#line 741 "ScoreBoard.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_IPC__ScoreBoard_have_atomics); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_have_atomics)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	IV	RETVAL;
	dXSTARG;
#line 363 "ScoreBoard.xs"
    RETVAL=HAVE_ATOMICS;
#line 759 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_IPC__ScoreBoard_offset_of); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_IPC__ScoreBoard_offset_of)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "sb, slot, idx=0");
    {
	SV*	sb = ST(0)
;
	UV	slot = (UV)SvUV(ST(1))
;
	UV	idx;
	IV	RETVAL;
	dXSTARG;

	if (items < 3)
	    idx = 0;
	else {
	    idx = (UV)SvUV(ST(2))
;
	}
#line 375 "ScoreBoard.xs"
    RETVAL=-1;
    if( expect_true((sb && SvROK(sb))) ) {
      struct hdr *hdr=(struct hdr *)SvPV_nolen(SvRV(sb));
      IV *data=(IV*)(sizeof(*hdr)+(char*)hdr);

      if( expect_true(items>2 && SvOK(ST(2))) ) {
	/* fetch slot offset */
	if( expect_true(slot<hdr->how_many) ) {
	  if( expect_true(idx<hdr->slotsize) ) {
	    RETVAL=(char*)&data[slot*hdr->slotsize+idx] - (char*)hdr;
	  } else {
	    croak("index within extra slot out of range");
	  }
	} else {
	  croak("slot number out of range");
	}
      } else {
	/* fetch extra offset */
	if( expect_true(slot<hdr->extra) ) {
	  RETVAL=(char*)&data[hdr->how_many*hdr->slotsize+slot] - (char*)hdr;
	} else {
	  croak("index within extra slot out of range");
	}
      }
    }
#line 813 "ScoreBoard.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_IPC__ScoreBoard); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_IPC__ScoreBoard)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("IPC::ScoreBoard::nslots", XS_IPC__ScoreBoard_nslots, file, "$");
        (void)newXSproto_portable("IPC::ScoreBoard::slotsize", XS_IPC__ScoreBoard_slotsize, file, "$");
        (void)newXSproto_portable("IPC::ScoreBoard::nextra", XS_IPC__ScoreBoard_nextra, file, "$");
        (void)newXSproto_portable("IPC::ScoreBoard::get", XS_IPC__ScoreBoard_get, file, "$$;$");
        (void)newXSproto_portable("IPC::ScoreBoard::set", XS_IPC__ScoreBoard_set, file, "$$$$");
        (void)newXSproto_portable("IPC::ScoreBoard::incr", XS_IPC__ScoreBoard_incr, file, "$$$;$");
        (void)newXSproto_portable("IPC::ScoreBoard::decr", XS_IPC__ScoreBoard_decr, file, "$$$;$");
        (void)newXSproto_portable("IPC::ScoreBoard::sum", XS_IPC__ScoreBoard_sum, file, "$$");
        (void)newXSproto_portable("IPC::ScoreBoard::get_all", XS_IPC__ScoreBoard_get_all, file, "$$");
        (void)newXSproto_portable("IPC::ScoreBoard::sum_all", XS_IPC__ScoreBoard_sum_all, file, "$");
        (void)newXSproto_portable("IPC::ScoreBoard::get_extra", XS_IPC__ScoreBoard_get_extra, file, "$;$");
        (void)newXSproto_portable("IPC::ScoreBoard::set_extra", XS_IPC__ScoreBoard_set_extra, file, "$$$");
        (void)newXSproto_portable("IPC::ScoreBoard::incr_extra", XS_IPC__ScoreBoard_incr_extra, file, "$$;$");
        (void)newXSproto_portable("IPC::ScoreBoard::decr_extra", XS_IPC__ScoreBoard_decr_extra, file, "$$;$");
        (void)newXSproto_portable("IPC::ScoreBoard::get_all_extra", XS_IPC__ScoreBoard_get_all_extra, file, "$");
        (void)newXSproto_portable("IPC::ScoreBoard::have_atomics", XS_IPC__ScoreBoard_have_atomics, file, "");
        (void)newXSproto_portable("IPC::ScoreBoard::offset_of", XS_IPC__ScoreBoard_offset_of, file, "$$;$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

